:
#	%Z% %M% %I% %D% %Q%
#
#	Copyright (C) The Santa Cruz Operation, 1985.
#	This Module contains Proprietary Information of
#	The Santa Cruz Operation, Microsoft Corporation
#	and AT&T, and should be treated as Confidential.
#

#!	Imagen laser printer parallel interface
#	Copyright 1985, IMAGEN Corp.
#	IMAGEN SYSTEM V Spooler Interface
#	for spooling impress, text, troff input, and troff output files
#
#	install with
#
#		lpadmin -p$printer -v$device -iimagen.int
#
#	where	$printer	- name associated with printer
#		$device		- physical device line
#
#	Invoke with:
#
#		lp -d$printer -n$copies -t$title [opts] files
#
#	Legal opts values are:
#
#		-oli	- input file is language imPress
#		-olp	- input file is text for line printing
#		-oldt	- input file is ditroff input
#		-olt	- input file is old style troff input
#		-olfi	- input file is full imPress file
#			  (already has document header)
#		-old	- input file is ditroff output, to be filtered
#			  thru dimp
#		-oldvi	- input file is dvi format (TEX output)
#		-olc	- input file is CAT format (old style troff output)
#		-ot$flags- options to be passed to troff
#			  ( e.g. "-ot-ms" )
#		-od$flags- options to be passed to dimp
#			  ( e.g. "-od-T300" )
#		-ov$flags- options to be passed to dviimp
#			  ( e.g. "-od-d" )
#		-oc$flags- options to be passed to catimp
#			  ( e.g. "-od-v" )
#		-oixxx	- document header flags for impress where xxx is
#			2 - print two forms per page
#			O - print outline on page
#			r - toggle page reversal
#			c - toggle page collation
#			J - toggle printing of job header page
#			R - print rules on page
#
#####################################################################
#
#

comm=/usr/lib/ipbs
bin=/usr/bin
lib=/usr/lib
troff=troff
ditroff=ditroff

#
#	programs and filters
#
dimp=$bin/dimp
dviimp=$bin/dviimp
catimp=$bin/catimp

#
#	options for document control
#
deflanguage=printer
forms=1
outlines=off
jobheader=on
pagereversal=on
pagecollation=on
formwidth=
rules=off

#
#	command line parameters
#
bname=$0
reqid=$1
usrid=$2
title=$3
copies=$4
options=$5
fname=$6

shift; shift; shift; shift; shift
files="$*"

printer=`basename $bname`
system=`uname`



#
#	parse the spooler device dependent options
#
for i in $options
do
	case "$1" in
	li)
		ftype=impress
		;;
	lp)
		ftype=printer
		;;
	lfi)
		ftype=fullimpress
		;;
	ldt)
		ftype=ditroff
		;;
	lt)
		ftype=troff
		;;
	ld)
		ftype=dimp
		;;
	ldvi)
		ftype=dvi
		;;
	lcat)
		ftype=cat
		;;
# M001
	t*)
		temp=`echo "$i" | sed 's/^.//'`
		tflags="$tflags $temp"
		;;
	c*)
		temp=`echo "$i" | sed 's/^.//'`
		cflags="$cflags $temp"
		;;
	v*)
		temp=`echo "$i" | sed 's/^.//'`
		dviflags="$dviflags $temp"
		;;
	d*)
		temp=`echo "$i" | sed 's/^.//'`
		dflags="$dflags $temp"
		;;
	i2)
		forms=2
		;;
	iO)
		if [ $outlines = on ]
		then outlines=off
		else outlines=on
		fi
		;;
	ir)
		if [ $pagereversal = on ]
		then pagereversal=off
		else pagereversal=on
		fi
		;;
	ic)
		if [ $pagecollation = on ]
		then pagecollation=off
		else pagecollation=on
		fi
		;;
	iR)
		if [ $rules = on ]
		then rules=off
		else rules=on
		fi
		;;
	iJ)
		if [ $jobheader = on ]
		then jobheader=off
		else jobheader=on
		fi
		;;

	esac

done





#
#	build the document header
#

if [ -n "$title" ]
then fname=$title
fi

iflags="jobheader $jobheader, job $reqid, date\"`date`\", file \"$fname\" "

if [ -n "$usrid" ]
then 
	iflags="name \"$usrid\", $iflags"
fi

if [ $outlines = on ]
then
	iflags="outlines on, $iflags"
fi

if [ $rules = on ]
then
	iflags="rules on, $iflags"
fi

if [ $forms != 1 ]
then
	iflags="formsperpage $forms, $iflags"
fi

iflags="printer $printer, system $system, copies $copies, $iflags"




#
#	invoke the specified filter for input
#
if [ -z "$ftype" ]
then
	ftype=$deflanguage
fi


(

case $ftype in
	fullimpress)
		cat $files 2>&1
		;;

	impress)
		echo "@Document(language impress, $iflags)\c"
		cat $files 2>&1
		;;

	dimp)
		echo "@Document(language impress, $iflags)\c"
		$dimp $dflags -t $files
		;;

	troff)
		echo "@Document(language impress, $iflags)\c"
		$troff $tflags $files | $catimp $cflags -i -
		;;

	cat)
		echo "@Document(language impress, $iflags)\c"
		$catimp $cflags $files -i -
		;;

	dvi)
		echo "@Document(language impress, $iflags)\c"
		$dviimp $dviflags $files -i -
		;;
	ditroff)
		echo "@Document(language impress, $iflags)\c"
		$troff $tflags $files | $dimp $dflags -t
		;;

	printer)
		echo "@Document(language printer, $iflags)\c"
		cat $files 2>&1
		;;

esac
) | $comm -s
